;************************************************************************
;       BCD To Binary Conversion
;
;       This routine converts a 4 digit BCD number to a 16 bit binary number.
;       The input 4 digit BCD numbers are asumed to be in locations
;       R0 to R2 with R0 containing the MSD in its right most nibble.
;       The 16 bit binary number is output in registers H_byte & L_byte
;************************************************************************
;
H_byte  equ     HI
L_byte  equ     LO
R0      equ     TEMP0          ; MSD (right)
R1      equ     TEMP1
R2      equ     TEMP2
R3      equ     TEMP3
;
H_temp  equ     HI_TEMP          ; temporary register
L_temp  equ     LO_TEMP          ; temporary register
;
;************************************************************************
ASC2BIN   clrf    H_byte
	movfw   R0
  andlw   0x0f
  movwf   L_byte
	call    mpy10a          ; result = 10a+b
	movfw   R1
  andlw   0x0f
	call    mpy10b          ; result = 10[10a+b]
  movfw   R2
  andlw   0x0f
	call    mpy10b          ; result = 10[10a+b]
  movfw   R3
  andlw   0x0f
	addwf   L_byte, F
	btfsc   STATUS,C
	incf    H_byte, F       ; result = 10[10[10[10a+b]+c]+d]+e
	retlw   0               ; BCD to binary conversion done
;************************************************************************
mpy10b  andlw   0x0F
	addwf   L_byte, F
	btfsc   STATUS,C
	incf    H_byte, F
mpy10a  bcf     STATUS,C        ; multiply by 2
	rlf     L_byte,W
	movwf   L_temp
	rlf     H_byte,W        ; (H_temp,L_temp) = 2*N
	movwf   H_temp
;
	bcf     STATUS,C        ; multiply by 2
	rlf     L_byte, F
	rlf     H_byte, F
	bcf     STATUS,C        ; multiply by 2
	rlf     L_byte, F
	rlf     H_byte, F
	bcf     STATUS,C        ; multiply by 2
	rlf     L_byte, F
	rlf     H_byte, F       ; (H_byte,L_byte) = 8*N
;
	movf    L_temp,W
	addwf   L_byte, F
	btfsc   STATUS,C
	incf    H_byte, F
	movf    H_temp,W
	addwf   H_byte, F
	retlw   0               ; (H_byte,L_byte) = 10*N
;************************************************************************
