;****************************************************************
; 16-bit routines
; define	HI,LO,HI_TEMP,LO_TEMP,HI_RESULT in main program
;****************************************************************
; (HI/LO) - (HI/LO_TEMP) => (HI/LO) Carry set if result >= 0
; 
sub16
	movfw	HI_TEMP
	subwf	HI,f
	movfw	LO_TEMP
	subwf	LO,f
	btfss	STATUS,C
	decf	HI,f
	return

;****************************************************************
; (HI/LO) + (HI/LO_TEMP => (HI/LO)
;
add16
	movfw	HI_TEMP
	addwf	HI,f
	movfw	LO_TEMP
	addwf	LO,f
	btfsc	STATUS,C
	incf	HI,f
	return

;****************************************************************
;	compare HI/LO to HI_TEMP/LO_TEMP

cmpequ16
	call	cmpless16
	iorwf	HI_RESULT,w		; Z set if equal, otherwise not set
	return

;subtraction for compare
cmpless16
	movfw	HI_TEMP			; Get the High Byte of the Result
	subwf	HI, w   
	movwf	HI_RESULT
	movfw	LO_TEMP			; Get the Low Byte 
	subwf	LO, w
	btfss	STATUS, C		; Decrement High if Necessary
	decf	HI_RESULT,f		; if HI/LO < HI/LO_TEMP then BIT7 of HI_RESULT is set
	return              

;****************************************************************
;****************************************************************
; Reg is LOwbyte, Reg+1 is HIghbyte
;****************************************************************
;Incrementing a 16 Bit value is very simple: 

incr16	macro	Reg
	incf	Reg, f              ; Increment the Low byte
	btfsc	STATUS, Z           ; Do we have Zero (Multiple of 256)?
	incf	Reg + 1, f          ;  Increment High byte (if necessary)
	endm              

;The Decrement of a 16 Bit value isn't quite so simple: 

decr16	macro	Reg
	movf	Reg, f              ;  Set "Z" if LOW "Reg" == 0
	btfsc	STATUS, Z 
	decf	Reg + 1, f          ;  If Low byte is Zero, Decrement High
	decf	Reg, f
	endm

;****************************************************************
;To shift left: 

shl16	macro	Reg
	bcf	STATUS, C            ;  Clear the Carry Flag for new bit
	rlf	Reg, f               ;  Shift the Low Byte
	rlf	Reg + 1, f           ;  Shift High Byte with Low Carry 
	endm              

;to shift right:

shr16	macro	Reg
	bcf	STATUS, C            ;  Clear Carry Flag for the New bit
	rrf	Reg + 1, f           ;  Shift down the High Byte
	rrf	Reg, f               ;  Shift Low Byte with Valid Carry 
	endm
;****************************************************************
;copy 16 number from file_a to file_b

cpy16	macro	file_a,file_b
	movfw	file_a
	movwf	file_b
	movfw	file_a+1
	movwf	file_b+1
	endm              
